## bareos 26.0.0~pre120.3946e86a7

=== core/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2017-2025 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.
message("Entering ${CMAKE_CURRENT_SOURCE_DIR}")
project(bareos C CXX)

if(DEBUG_TARGET_DEPENDENCIES)
  set(CMAKE_FIND_PACKAGE_TARGETS_GLOBAL ON)
endif()

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  message(
    FATAL_ERROR
      "Building from bareos/core/ is not supported anymore. Use bareos/ instead"
  )
endif()

# disable in-source builds
if("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
  message(FATAL_ERROR "In-source builds are not allowed.")
endif()

set(CMAKE_INSTALL_DEFAULT_COMPONENT_NAME common)

include(BareosHelper)

# switch on CXX 20 Support
#
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
# enable PIC/PIE by default
include(CheckPIESupported)
check_pie_supported()
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

option(ENABLE_SANITIZERS "Build with ASan/LSan/UBSan enabled" OFF)
if(ENABLE_SANITIZERS)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS
        "${CMAKE_CXX_FLAGS} -fsanitize=undefined -fsanitize=address -fno-sanitize-recover"
    )
    set(CMAKE_C_FLAGS
        "${CMAKE_C_FLAGS} -fsanitize=undefined -fsanitize=address -fno-sanitize-recover"
    )

    add_compile_definitions(BAREOS_UB_SANITIZER=1 BAREOS_ADDRESS_SANITIZER=1)
  elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS
        "${CMAKE_CXX_FLAGS} -fsanitize=undefined -fsanitize=address -fno-sanitize-recover"
    )
    set(CMAKE_C_FLAGS
        "${CMAKE_C_FLAGS} -fsanitize=undefined -fsanitize=address -fno-sanitize-recover"
    )
    add_compile_definitions(BAREOS_UB_SANITIZER=1 BAREOS_ADDRESS_SANITIZER=1)
  elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=address")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /fsanitize=address")
    add_compile_definitions(BAREOS_ADDRESS_SANITIZER=1)
  else()
    message(
      FATAL_ERROR
        "Cannot (yet) compile with sanitizers on ${CMAKE_C_COMPILER_ID}"
    )
  endif()
endif()

option(ENABLE_THREAD_SANITIZERS "Build with TSan enabled" OFF)
if(ENABLE_THREAD_SANITIZERS)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS
        "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-sanitize-recover"
    )
    set(CMAKE_C_FLAGS
        "${CMAKE_C_FLAGS} -fsanitize=thread -fno-sanitize-recover"
    )

    add_compile_definitions(BAREOS_THREAD_SANITIZER=1)
  elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS
        "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-sanitize-recover"
    )
    set(CMAKE_C_FLAGS
        "${CMAKE_C_FLAGS} -fsanitize=thread -fno-sanitize-recover"
    )
    add_compile_definitions(BAREOS_THREAD_SANITIZER=1)
  elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=thread")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /fsanitize=thread")
    add_compile_definitions(BAREOS_THREAD_SANITIZER=1)
  else()
    message(
      FATAL_ERROR
        "Cannot (yet) compile with sanitizers on ${CMAKE_C_COMPILER_ID}"
    )
  endif()
endif()

if(ENABLE_THREAD_SANITIZERS AND ENABLE_SANITIZERS)
  message(
    WARNING
      "enabling both thread sanitizer and address sanitizer is not supported"
  )
endif()

option(ENABLE_STATIC_RUNTIME_LIBS "Link C and C++ runtime libraries statically"
       OFF
)
if(ENABLE_STATIC_RUNTIME_LIBS)
  if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -static-libgcc -static-libstdc++")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -static-libgcc")
  else()
    message(
      FATAL_ERROR
        "Cannot (yet) do static runtime-libraries on ${CMAKE_C_COMPILER_ID}"
    )
  endif()
endif()

if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.18.0)
  include(CheckLinkerFlag)
  check_linker_flag(CXX "-Wl,--as-needed" LD_SUPPORTS_AS_NEEDED)
  if(LD_SUPPORTS_AS_NEEDED AND NOT CMAKE_LINK_WHAT_YOU_USE)
    add_link_options("-Wl,--as-needed")
  endif()
endif()

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wsuggest-override compiler_will_suggest_override)

if(${compiler_will_suggest_override})
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-override")
endif()

if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
  # make format-security issues a compiler-error
  check_cxx_compiler_flag(-Wformat compiler_format_security)
  if(${compiler_format_security})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wformat")
  endif()
  check_cxx_compiler_flag(
    -Werror=format-security compiler_error_format_security
  )
  if(${compiler_error_format_security})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=format-security")
  endif()
endif()

check_cxx_compiler_flag(-Winvalid-offsetof compiler_has_invalid_offsetof)
if(compiler_has_invalid_offsetof)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-invalid-offsetof")
endif()

# warn on sign-conversion include(CheckCCompilerFlag)
# CHECK_C_COMPILER_FLAG(-Wsign-conversion c_compiler_will_warn_sign_conversion)
#
# if (${c_compiler_will_warn_sign_conversion}) set (CMAKE_C_FLAGS
# "${CMAKE_C_FLAGS} -Wsign-conversion") endif()
#
# CHECK_CXX_COMPILER_FLAG(-Wsign-conversion
# cxx_compiler_will_warn_sign_conversion)
#
# if (${cxx_compiler_will_warn_sign_conversion}) set (CMAKE_CXX_FLAGS
# "${CMAKE_CXX_FLAGS} -Wsign-conversion") endif()

if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  include_directories(/usr/include)
endif()

set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/../../SOURCES
    ${PROJECT_SOURCE_DIR}/../../../SOURCES ${PROJECT_SOURCE_DIR}/../SOURCES
    ${PROJECT_SOURCE_DIR}/cmake
)

set(host ${CMAKE_SYSTEM})

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

include(BareosGetDistInfo)

set(BUILDNAME
    "${BAREOS_NUMERIC_VERSION}"
    CACHE STRING "site name variable for CDash"
)
set(SITE
    "${CMAKE_SYSTEM_NAME}-${DISTVER}-${CMAKE_HOST_SYSTEM_PROCESSOR}"
    CACHE STRING "build name variable for CDash"
)
# enable "make test"
enable_testing()
set(CMAKE_CTEST_COMMAND ctest -V)
include(CTest)

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set(HAVE_DARWIN_OS 1)
  if(DEFINED ENV{HOMEBREW_PREFIX})
    set(HOMEBREW_PREFIX "$ENV{HOMEBREW_PREFIX}")
  else()
    set(HOMEBREW_PREFIX "/usr/local")
  endif()

  set(OPENSSL_ROOT_DIR ${HOMEBREW_PREFIX}/opt/openssl@3)
  set(Readline_ROOT_DIR ${HOMEBREW_PREFIX}/opt/readline)
  set(Intl_ROOT_DIR ${HOMEBREW_PREFIX}/opt/gettext)
endif()

include(BareosFindAllLibraries)

if(MSVC)
  set(THREADS_THREADS "PThreads4W::PThreads4W_CXXEXC")
else()
  set(THREADS_THREADS "Threads::Threads")
endif()

include(BareosFindPrograms)

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set(HAVE_LINUX_OS 1)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
  set(HAVE_SUN_OS 1)
  link_libraries(nsl socket curses sec)

  if(${CMAKE_C_COMPILER_ID} MATCHES SunPro)
    include_directories(/usr/local/include)
    link_directories(/usr/local/lib)

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m64")
  endif()

  if(${CMAKE_CXX_COMPILER_ID} MATCHES SunPro)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64")
  endif()
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  set(HAVE_FREEBSD_OS 1)
  include_directories(SYSTEM /usr/local/include)
  link_directories(/usr/local/lib)
  link_libraries(intl)
  check_cxx_compiler_flag(
    -Wunused-but-set-variable compiler_will_warn_of_unused_but_set_variable
  )
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  # set(CMAKE_INCLUDE_PATH  "${OPENSSL_INCLUDE_DIR}:${CMAKE_INCLUDE_PATH}")
  set(CMAKE_INCLUDE_PATH "${HOMEBREW_PREFIX}/opt/:${CMAKE_INCLUDE_PATH}")
  link_directories(${HOMEBREW_PREFIX}/lib)

  include_directories(${HOMEBREW_PREFIX}/opt/gettext/include)
  link_libraries(
    ${HOMEBREW_PREFIX}/opt/gettext/lib/libintl.a iconv
    "-framework CoreFoundation" "-framework CoreServices"
  )
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "AIX")
  set(HAVE_AIX_OS 1)
  set(lmdb OFF)
  link_libraries(intl)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  include_directories(
    SYSTEM ${PROJECT_SOURCE_DIR}/src/win32/include
    ${PROJECT_SOURCE_DIR}/src/win32/compat/include
  )
  if(MSVC)
    link_libraries(Intl::Intl)
  endif()

  set(HAVE_WIN32 1)

  if(MSVC)
    set(PostgreSQL_INCLUDE_DIR "")
    set(PostgreSQL_TYPE_INCLUDE_DIR "")
  endif()
  set(dynamic-storage-backends
      OFF
      CACHE BOOL "Enable dynamic storage backends" FORCE
  )
  set(HAVE_DYNAMIC_SD_BACKENDS
      0
      CACHE INTERNAL "" FORCE
  )

else()
  add_compile_definitions("_FILE_OFFSET_BITS=64")
endif()

if(MSVC)
  set(BAREOS_WARNING_FLAGS
      /W4 # enable all reasonable warnings, but disable the following
      /wd4273 # inconsistent dll linkage
      /wd4127 # conditional expression is constant
      /wd4244 # conversion warning
      /wd4245 # conversion warning
      /wd4267 # conversion warning
      /wd4389 # sign mismatch
      /D_CRT_SECURE_NO_DEPRECATE # deprecation warning for stdlib functions
  )
else()
  set(BAREOS_WARNING_FLAGS -Werror -Wall -Wextra -Wshadow)
endif()
list(JOIN BAREOS_WARNING_FLAGS " " BAREOS_WARNING_FLAGS_STRING)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${BAREOS_WARNING_FLAGS_STRING}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${BAREOS_WARNING_FLAGS_STRING}")

option(ENABLE_BCONSOLE "Build bconsole binary" ON)

if(${CMAKE_SYSTEM_NAME} MATCHES "AIX")
  set(ENABLE_NLS 0)
endif()
include(BareosFindStaticCodeAnalysisTools)

if(NOT client-only
   AND NOT ${CMAKE_SYSTEM_NAME} MATCHES "SunOS"
   AND CMAKE_SIZEOF_VOID_P EQUAL 8
)
  # droplet does not build on solaris because of sys/cdefs.h: No such file or
  # directory it is also not safe on 32-bit systems, so we only build it on
  # 64-bit
  add_subdirectory(src/droplet)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  if(MSVC)
    add_definitions(
      -DWIN32_VSS -DMINGW64 -DHAVE_WIN32 -D_WIN32_WINNT=${WINDOWS_VERSION}
      -DWINVER=${WINDOWS_VERSION}
    )
    # add parallel builds (-MP)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -MP")
    # export all symbols of dlls trick in cmake
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
  endif()

  set(Python3_SITEARCH ${plugindir})
endif()

# set INSTALL_LIB_DIR automatically to lib or lib64 automatically Taken from
# https://cmake.org/pipermail/cmake/2013-July/055374.html

get_property(LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
if("${LIB64}" STREQUAL "TRUE")
  set(LIBSUFFIX 64)
else()
  set(LIBSUFFIX "")
endif()
set(INSTALL_LIB_DIR
    "usr/lib${LIBSUFFIX}"
    CACHE PATH "Installation directory for libraries"
)
mark_as_advanced(INSTALL_LIB_DIR)

# RPATH settings (from https://cmake.org/Wiki/CMake_RPATH_handling)
set(CMAKE_SKIP_BUILD_RPATH FALSE)

set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

set(CMAKE_INSTALL_RPATH "${libdir}")

set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# manual definitions
set(BAREOS "Bareos")
if(MSVC)
  set(LOCALEDIR \".\")
else()
  set(LOCALEDIR \"${CMAKE_INSTALL_LOCALEDIR}\")
endif()

include(TestBigEndian)
test_big_endian(IS_BIGENDIAN)
if(IS_BIGENDIAN)
  set(HAVE_BIG_ENDIAN 1)
endif()

message(STATUS "VERSION: " ${CMAKE_MATCH_1})
message(STATUS "PROJECT_SOURCE_DIR:         " ${PROJECT_SOURCE_DIR})

# needed for check_include
set(CMAKE_REQUIRED_DEFINITIONS "-D_FILE_OFFSET_BITS=64")

include(BareosCheckIncludes)

include(BareosCheckFunctions)

include(BareosCheckSymbols)

=== core/platforms/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2017-2026 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.
message("Entering ${CMAKE_CURRENT_SOURCE_DIR}")

if(NOT HAVE_WIN32)

  message(STATUS "UNITDIR: " ${UNITDIR})
  message(STATUS "BAREOS_PLATFORM: " ${BAREOS_PLATFORM})

  set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
  if(${BAREOS_PLATFORM} STREQUAL ubuntu)
    add_subdirectory(debian)
  elseif(${BAREOS_PLATFORM} STREQUAL univention)
    message(STATUS "adding subdirectories debian and univention")
    add_subdirectory(debian)
    add_subdirectory(univention)
  elseif(${systemd})
    add_subdirectory(systemd)
  elseif(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${BAREOS_PLATFORM}")
    add_subdirectory(${BAREOS_PLATFORM})
  endif()
else()
  add_subdirectory(win32)
endif()

=== contrib/misc/media_vault/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2025-2025 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.

message("Entering ${CMAKE_CURRENT_SOURCE_DIR}")

include(GNUInstallDirs)

set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/../../SOURCES
    ${PROJECT_SOURCE_DIR}/../SOURCES ${PROJECT_SOURCE_DIR}/cmake
)

include(BareosLocalBuildDefinitions OPTIONAL
        RESULT_VARIABLE BareosLocalBuildDefinitionsFile
)

include(BareosConfigureFile)
include(BareosInstallConfigFiles)

bareos_configure_file(
  FILES
  media_vault.sh.in
  media_vault.ini.example.in
  job_admin-media_vault.conf.example.in
)

install(
  FILES media_vault.py
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
              WORLD_READ WORLD_EXECUTE
  DESTINATION "${scriptdir}"
)

install(
  FILES "${CMAKE_CURRENT_BINARY_DIR}/media_vault.sh"
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
              WORLD_READ WORLD_EXECUTE
  DESTINATION "${scriptdir}"
)

install(
  CODE "
  bareos_install_single_config_file(\"${CMAKE_CURRENT_BINARY_DIR}/media_vault.ini.example\" \"${configtemplatedir}\" \"\")
"
)

install(
  CODE "
  bareos_install_single_config_file(\"${CMAKE_CURRENT_SOURCE_DIR}/console_media_vault.conf.example\" \"${configtemplatedir}\" \"bareos-dir.d/console\")
"
)

install(
  CODE "
  bareos_install_single_config_file(\"${CMAKE_CURRENT_BINARY_DIR}/job_admin-media_vault.conf.example\" \"${configtemplatedir}\" \"bareos-dir.d/job\")
"
)

install(
  CODE "
  bareos_install_single_config_file(\"${CMAKE_CURRENT_SOURCE_DIR}/profile_media_vault.conf.example\" \"${configtemplatedir}\" \"bareos-dir.d/profile\")
"
)

=== core/src/lib/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2017-2025 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.
message("Entering ${CMAKE_CURRENT_SOURCE_DIR}")

add_library(bareos SHARED)
add_library(Bareos::Lib ALIAS bareos)
target_sources(
  bareos
  PRIVATE address_conf.cc
          alist.cc
          attr.cc
          attribs.cc
          bareos_universal_initialiser.cc
          backtrace.cc
          base64.cc
          berrno.cc
          bget_msg.cc
          binflate.cc
          bnet_server_tcp.cc
          bnet.cc
          bnet_network_dump.cc
          bnet_network_dump_private.cc
          bpipe.cc
          breg.cc
          bsnprintf.cc
          bsock.cc
          bsock_tcp.cc
          bstringlist.cc
          bsys.cc
          btime.cc
          btimers.cc
          cbuf.cc
          cli.cc
          connection_pool.cc
          cram_md5.cc
          crypto.cc
          crypto_cache.cc
          crypto_openssl.cc
          crypto_wrap.cc
          daemon.cc
          devlock.cc
          dlist_string.cc
          edit.cc
          fnmatch.cc
          guid_to_name.cc
          hmac.cc
          htable.cc
          jcr.cc
          lockmgr.cc
          mem_pool.cc
          message.cc
          messages_resource.cc
          mntent_cache.cc
          monotonic_buffer.cc
          output_formatter.cc
          output_formatter_resource.cc
          passphrase.cc
          path_list.cc
          plugins.cc
          bpoll.cc
          priv.cc
          recent_job_results_list.cc
          rblist.cc
          runscript.cc
          rwlock.cc
          scan.cc
          scsi_crypto.cc
          scsi_lli.cc
          serial.cc
          signal.cc
          status_packet.cc
          thread_list.cc
          thread_specific_data.cc
          tls.cc
          tls_conf.cc
          tls_openssl.cc
          tls_openssl_private.cc
          tree.cc
          try_tls_handshake_as_a_server.cc
          compression.cc
          util.cc
          var.cc
          watchdog.cc
          xxhash.cc
)

if(HAVE_WIN32)
  target_sources(bareos PRIVATE bpipe_win32.cc)
  target_sources(
    bareos PRIVATE ../win32/compat/compat.cc ../win32/compat/glob.cc
                   ../win32/compat/winapi.cc
  )
  target_sources(bareos PRIVATE osinfo_win32.cc)
  target_link_libraries(bareos PUBLIC ws2_32)

  find_package(pcre2 CONFIG REQUIRED)
  target_link_libraries(bareos PUBLIC PCRE2::POSIX)
else()
  target_sources(bareos PRIVATE bpipe_unix.cc)
  target_sources(bareos PRIVATE scsi_tapealert.cc)
  target_sources(bareos PRIVATE osinfo_unix.cc)
endif()

target_sources(
  bareos
  PRIVATE bareos_resource.cc
          configured_tls_policy_getter.cc
          lex.cc
          parse_bsr.cc
          res.cc
          parse_conf.cc
          parse_conf_init_resource.cc
          parse_conf_state_machine.cc
          res.cc
          qualified_resource_name_type_converter.cc
)

# this is done to ensure every other object can be cached
add_library(version-obj OBJECT version.cc)
target_compile_definitions(
  version-obj
  PRIVATE -DBAREOS_VERSION="${BAREOS_FULL_VERSION}"
          -DBAREOS_DATE="${DATE}"
          -DBAREOS_SHORT_DATE="${BAREOS_SHORT_DATE}"
          -DBAREOS_PROG_DATE_TIME="${BAREOS_PROG_DATE_TIME}"
          -DBAREOS_YEAR="${BAREOS_YEAR}"
)

target_link_libraries(
  bareos
  PRIVATE version-obj Bareos::Fastlz OpenSSL::SSL ZLIB::ZLIB CLI11::CLI11
          xxHash::xxhash utf8cpp::utf8cpp ${CMAKE_DL_LIBS}
  PUBLIC ${THREADS_THREADS}
)

if(TARGET Bareos::LowLevelScsi)
  target_link_libraries(bareos PRIVATE Bareos::LowLevelScsi)
endif()

if(ENABLE_LZO)
  target_link_libraries(bareos PRIVATE LZO::LZO)
endif()

if(XXHASH_ENABLE_DISPATCH)
  set_source_files_properties(
    xxhash.cc PROPERTIES COMPILE_FLAGS "-DXXHASH_ENABLE_DISPATCH"
  )
endif()

if(CMAKE_CXX_FLAGS MATCHES "-fsanitize=address"
   AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU"
   AND CMAKE_CXX_COMPILER_VERSION MATCHES "^1[234]"
)
  # work around compiler/stdlib bug see
  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=105562#c17
  set_source_files_properties(
    cli.cc PROPERTIES COMPILE_FLAGS "-Wno-maybe-uninitialized"
  )
endif()

if(ENABLE_CAPABILITY)
  target_link_libraries(bareos PRIVATE cap)
endif()

if(TARGET Jansson::Jansson)
  target_link_libraries(bareos PUBLIC Jansson::Jansson)
endif()

install(TARGETS bareos DESTINATION ${libdir})

set_target_properties(
  bareos PROPERTIES VERSION "${BAREOS_NUMERIC_VERSION}"
                    SOVERSION "${BAREOS_VERSION_MAJOR}"
)

include(DebugEdit)

=== core/src/plugins/filed/windows_dr/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2025-2026 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.

include(BareosDisableWarnings)
include(BareosConfigureFile)

add_library(format INTERFACE)
if(HAVE_WIN32)
  target_compile_options(format INTERFACE "-DUSE_STD_FMT=1")
else()
  target_link_libraries(format INTERFACE fmt::fmt)
endif()

add_library(progress-bar-logger OBJECT logger.cc)
target_link_libraries(progress-bar-logger PRIVATE format)

bareos_add_plugin(barri-fd)
target_link_libraries(
  barri-fd
  PUBLIC Bareos::Lib
  PRIVATE format
)
target_compile_definitions(barri-fd PRIVATE PLUGIN_NAME="barri")
install(
  TARGETS barri-fd
  DESTINATION ${plugindir}
  COMPONENT filedaemon
)

add_library(barri-version OBJECT)
target_sources(barri-version PRIVATE version.cc)
target_compile_definitions(
  barri-version PRIVATE "BARRI_VERSION=${BAREOS_FULL_VERSION}"
                        "BARRI_DATE=${DATE}" "BARRI_YEAR=${BAREOS_YEAR}"
)

add_library(parser OBJECT)
add_library(Bareos::BarriParser ALIAS parser)
target_sources(parser PRIVATE parser.cc)
target_include_directories(parser PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(parser PUBLIC format)

if(HAVE_WIN32)
  add_library(dump OBJECT)
  target_sources(
    dump PRIVATE dump.cc common.cc com.cc restore_win.cc parser.cc
                 remove_holes.cc
  )
  target_include_directories(dump PUBLIC "${CMAKE_CURRENT_LIST_DIR}")
  add_library(Bareos::BarriDump ALIAS dump)
  target_link_libraries(
    dump
    PRIVATE VssApi.lib virtdisk.lib ZLIB::ZLIB
    PUBLIC format Microsoft.GSL::GSL
  )

  target_sources(barri-fd PRIVATE plugin.cc bareos_api.cc)
  target_link_libraries(barri-fd PRIVATE dump)

  add_executable(barri-cli barri.cc)
  target_link_libraries(
    barri-cli CLI11::CLI11 progress-bar-logger dump format barri-version
  )
else()
  bareos_disable_warnings(TARGETS progress-bar-logger WARNINGS "-Wshadow")

  add_library(windows-dr-restore OBJECT)
  target_sources(windows-dr-restore PRIVATE restore_linux.cc parser.cc)
  target_link_libraries(windows-dr-restore PUBLIC Microsoft.GSL::GSL format)

  target_sources(barri-fd PRIVATE plugin_linux.cc bareos_api.cc)
  target_link_libraries(barri-fd PRIVATE tl::expected windows-dr-restore)

  add_executable(barri-cli barri_linux.cc)
  target_link_libraries(
    barri-cli PRIVATE CLI11::CLI11 ZLIB::ZLIB progress-bar-logger
                      windows-dr-restore barri-version
  )

  install(
    TARGETS barri-cli
    DESTINATION ${bindir}
    COMPONENT filedaemon
  )
endif()

add_executable(logger_test)
target_sources(logger_test PRIVATE logger_test.cc)
target_link_libraries(logger_test PRIVATE progress-bar-logger format)

include(DebugEdit)

=== debian/changelog ===
bareos (26.0.0~pre120.3946e86a7-18) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Tue, 27 Jan 2026 14:10:01 +0000

## bareos 26.0.0~pre133.2cc115ebb

=== debian/changelog ===
bareos (26.0.0~pre133.2cc115ebb-4) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Fri, 06 Feb 2026 18:37:06 +0000

## bareos 26.0.0~pre137.ac97412c9

=== systemtests/tests/CMakeLists.txt ===
#   BAREOS® - Backup Archiving REcovery Open Sourced
#
#   Copyright (C) 2021-2026 Bareos GmbH & Co. KG
#
#   This program is Free Software; you can redistribute it and/or
#   modify it under the terms of version three of the GNU Affero General Public
#   License as published by the Free Software Foundation and included
#   in the file LICENSE.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#   Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
#   02110-1301, USA.

message("Adding systemtests from ${CMAKE_CURRENT_SOURCE_DIR}")
add_subdirectory(accurate-lmdb-stresstest)
add_subdirectory(accurate-stresstest)
add_subdirectory(acl)
add_subdirectory(admin-job)
add_subdirectory(always-incremental-consolidate)
add_subdirectory(autochanger)
add_subdirectory(autoxflate)
add_subdirectory(auto-grpc)
add_subdirectory(bareos-basic)
add_subdirectory(bareos-concurrency)
add_subdirectory(bareos-acl)
add_subdirectory(bconsole-basic)
add_subdirectory(bconsole-pam)
add_subdirectory(block-size)
add_subdirectory(bpipe-fd)
add_subdirectory(bscan-bextract-bls-bcopy-btape)
add_subdirectory(catalog)
add_subdirectory(checkpoints)
add_subdirectory(chflags)
add_subdirectory(client-initiated)
add_subdirectory(commandline-options)
add_subdirectory(config-default)
add_subdirectory(config-dump)
add_subdirectory(copy-archive-job)
add_subdirectory(copy-migrate)
add_subdirectory(copy-remote-bscan)
add_subdirectory(dbcheck)
add_subdirectory(dedupable)
add_subdirectory(dedupestimate)
add_subdirectory(deprecation)
add_subdirectory(dplcompat)
add_subdirectory(encrypt-signature-no-tls)
add_subdirectory(encrypt-signature-tls-cert)
add_subdirectory(fileindex-overflow)
if(HAVE_DYNAMIC_SD_BACKENDS)
  add_subdirectory(file-autochanger)
endif()
add_subdirectory(file-count-regression)
add_subdirectory(fileset-multiple-blocks)
add_subdirectory(filesets)
add_subdirectory(grpc-fd)
add_subdirectory(heartbeat-interval)
add_subdirectory(ignoreduplicatecheck)
add_subdirectory(just-in-time-reservation)
add_subdirectory(list-backups)
add_subdirectory(messages)
add_subdirectory(mtx-changer)
add_subdirectory(multiplied-device)
add_subdirectory(multiple-clients)
add_subdirectory(ndmp-bareos)
add_subdirectory(ndmp-native)
if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  add_subdirectory(mssqlvdi-plugin)
  add_subdirectory(hyper-v-plugin)
endif()
add_subdirectory(notls)
add_subdirectory(parallel-jobs)
add_subdirectory(parser)
add_subdirectory(passive)
add_subdirectory(pruning)
add_subdirectory(py3plug-fd-basic)
add_subdirectory(py3plug-fd-contrib-bareos_tasks_mariadb)
add_subdirectory(py3plug-fd-contrib-bareos_tasks_mysql)
add_subdirectory(py3plug-fd-contrib-mariadb-dump)
add_subdirectory(py3plug-fd-contrib-mysql_dump)
add_subdirectory(py3plug-fd-ldap)
add_subdirectory(py3plug-fd-libcloud)
add_subdirectory(py3plug-fd-local-fileset-basic)
add_subdirectory(py3plug-fd-local-fileset-restoreobject)
add_subdirectory(py3plug-fd-mariabackup)
add_subdirectory(py3plug-fd-percona-xtrabackup)
add_subdirectory(py3plug-fd-proxmox)
add_subdirectory(py3plug-fd-postgresql)
add_subdirectory(py3plug-fd-vmware)

add_subdirectory(py3plug-dir)
add_subdirectory(py3plug-sd)

add_subdirectory(python-bareos)
add_subdirectory(python-pam)
add_subdirectory(quota-softquota)
add_subdirectory(random-commands)
add_subdirectory(reload)
add_subdirectory(restapi)
add_subdirectory(restore)
add_subdirectory(scheduler)
add_subdirectory(scsicrypto)
add_subdirectory(sd-volume-limit)
add_subdirectory(sparse-file)
add_subdirectory(spool)
add_subdirectory(stresstest)
add_subdirectory(strippath)
add_subdirectory(testfind)
add_subdirectory(tlsrestricted)
add_subdirectory(tls-suites)
add_subdirectory(truncate-command)
add_subdirectory(upgrade-database)
add_subdirectory(virtualfull-basic)
add_subdirectory(virtualfull-bscan)
add_subdirectory(virtualfull-deletedfiles)
add_subdirectory(xattr)

=== debian/changelog ===
bareos (26.0.0~pre137.ac97412c9-13) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Tue, 10 Feb 2026 10:49:06 +0000

=== debian/control ===
# This file is autogenerated via cmake!
# If you need to regenerate it, run
#
#    make generate-debian-control
#
# debian/rules will do it automatically during the
# configuration phase

# we use conditional build-depends based on build profiles
# to get the right build-depends just fill DEB_BUILD_PROFILES
# with your distribution and codename (i.e. "debian buster"
# or "ubuntu xenial") and you'll get the full build-depends.
# Otherwise you will just get the common build-depends and
# might miss a feature or two.

Source: bareos
Section: admin
Priority: optional
Maintainer: Joerg Steffens <joerg.steffens@bareos.com>
Build-Depends: acl-dev,
 apache2 | httpd,
 bc,
 chrpath,
 cmake (>= 3.17.0),
 debhelper (>= 9.20160709),
 dpkg-dev (>= 1.13.19),
 libacl1-dev,
 libcap-dev [linux-any],
 liblzo2-dev,
 qt6-base-dev | qtbase5-dev,
 libreadline-dev,
 libssl-dev,
 libx11-dev,
 libxml2-dev,
 libxxhash-dev (>= 0.8.0) <bookworm> <bullseye> <noble> <jammy>,
 libcli11-dev (>= 2.1.2) <bookworm> <noble> <jammy>,
 libexpected-dev (>= 1.0.0~) <bookworm> <bullseye> <noble> <jammy>,
 libfmt-dev (>= 6.3.1) <bookworm> <bullseye> <noble> <jammy>,
 libmsgsl-dev (>= 4.0.0) <bookworm> <noble> <jammy>,
 libutfcpp-dev (>= 2.3.4) <bookworm> <bullseye> <noble> <jammy>,
 libpq-dev,
 libjansson-dev,
 libjson-c-dev,
 logrotate,
 lsb-release,
 mtx [!hurd-any],
 ncurses-dev,
 openssl (>= 1.1.1),
 pkg-config,
 po-debconf (>= 0.8.2),
 python3-dev,
 zlib1g-dev,
 systemd
Build-Conflicts: python2.2-dev, python2.3, python2.4, qt3-dev-tools, libqt4-dev
Standards-Version: 3.9.6
Vcs-Git: git://github.com/bareos/bareos.git -b master
Vcs-Browser: https://github.com/bareos/bareos/tree/master
Homepage: http://www.bareos.org/


Package:        bareos
Architecture:   any
Depends:        bareos-director (= ${binary:Version}), bareos-storage (= ${binary:Version}), bareos-client (= ${binary:Version}), ${misc:Depends}
Description: Backup Archiving Recovery Open Sourced - metapackage
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 It is efficient and relatively easy to use, while offering many advanced
 storage management features that make it easy to find and recover lost or
 damaged files. Due to its modular design, Bareos is scalable from small
 single computer systems to networks of hundreds of machines.
 .
 This metapackage installs the entire suite of Bareos applications: job
 scheduling, storage control, node connector, and administrative console.


Package:        bareos-bconsole
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0
Depends:        bareos-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Conflicts:      bacula-console
Replaces:       bacula-console
Description: Backup Archiving Recovery Open Sourced - text console
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The management console allows the administrator or user to
 communicate with the Bareos Director.
 .
 This package provides the text-interface version of the console.


Package:        bareos-client
Architecture:   any
Depends:        bareos-bconsole (>= ${binary:Version}), bareos-filedaemon (>= ${binary:Version}), ${misc:Depends}
Suggests:       bareos-traymonitor
Description: Backup Archiving Recovery Open Sourced - client metapackage
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The package is a metapackage for client installations (file daemon and
 console).


Package:        bareos-common
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0, adduser, coreutils, findutils, grep, gawk, libc-bin, passwd, openssl, sed
Depends:        ${shlibs:Depends}, ${misc:Depends}
Conflicts:      bacula-director-common, bacula-common
Description: Backup Archiving Recovery Open Sourced - common files
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides files that are useful for other Bareos packages.


Package:        bareos-database-common
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0
Depends:        bareos-common (= ${binary:Version}), bareos-database-postgresql (= ${binary:Version}), dbconfig-common, lsb-base (>= 3.2-13), ${shlibs:Depends}, ${misc:Depends}
Description: Backup Archiving Recovery Open Sourced - common catalog files
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides generic abstraction libs and files to connect the Bareos
 Director daemon to a database.


Package:        bareos-database-postgresql
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0
Depends:        dbconfig-pgsql | dbconfig-no-thanks, lsb-base (>= 3.2-13), postgresql-client, ${shlibs:Depends}, ${misc:Depends}
Suggests:       postgresql
Description: Backup Archiving Recovery Open Sourced - PostgreSQL backend
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides the functionality to connect the Bareos Director
 daemon to a PostgreSQL database.


Package:        bareos-database-tools
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0
Depends:        bareos-common (= ${binary:Version}), bareos-database-common (= ${binary:Version}), lsb-base (>= 3.2-13), ${shlibs:Depends}, ${misc:Depends}
Conflicts:      bacula-sd-mysql, bacula-sd-pgsql, bacula-sd-sqlite3
Description: Backup Archiving Recovery Open Sourced - database tools
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides tools that requires access to the Bareos database.


Package: bareos-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    bareos-storage (= ${binary:Version}) | bareos-bconsole (= ${binary:Version}) | bareos-common (= ${binary:Version}) | bareos-database-common (= ${binary:Version}) | bareos-database-postgresql (= ${binary:Version}) | bareos-database-tools (= ${binary:Version}) | bareos-director (= ${binary:Version}) | bareos-filedaemon (= ${binary:Version}) | bareos-storage (= ${binary:Version}) | bareos-storage-tape (= ${binary:Version}) | bareos-storage-fifo (= ${binary:Version}) | bareos-tools (= ${binary:Version}),
    ${misc:Depends}
Conflicts: bacula-sd-dbg, bacula-sd-mysql-dbg, bacula-sd-pgsql-dbg, bacula-sd-sqlite3-dbg
Description: Backup Archiving Recovery Open Sourced - debugging symbols
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package provides debugging symbols for Bareos.


Package:        bareos-director
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0, adduser
Depends:        bareos-common (= ${binary:Version}), bareos-database-common (= ${binary:Version}), bareos-database-tools, lsb-base (>= 3.2-13), lsof, bsd-mailx | mailx, ${shlibs:Depends}, ${misc:Depends}
Recommends:     logrotate
Conflicts:      bacula-director
Replaces:       bacula-director
Description: Backup Archiving Recovery Open Sourced - director daemon
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The Bareos Director service supervises all the backup, restore, verify and
 archive operations. It can run as a daemon or as a foreground service which
 administrators can use to schedule backups and recover files.
 .
 This package contains the Bareos Director daemon.


Package:        bareos-filedaemon
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0, adduser
Depends:        bareos-common (= ${binary:Version}), lsb-base (>= 3.2-13), lsof, ${shlibs:Depends}, ${misc:Depends}
Conflicts:      bacula-fd
Replaces:       bacula-fd, bareos-universal-client
Description: Backup Archiving Recovery Open Sourced - file daemon
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The file daemon has to be installed on the machine to be backed up. It is
 responsible for providing the file attributes and data when requested by
 the Director, and also for the file system-dependent part of restoration.
 .
 This package contains the Bareos File daemon.


Package:        bareos-storage
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0, adduser
Depends:        bareos-common (= ${binary:Version}), lsb-base (>= 3.2-13), lsof, ${shlibs:Depends}, ${misc:Depends}
Recommends:     bareos-tools
Conflicts:      bacula-sd
Replaces:       bacula-sd
Breaks:         bareos-storage-tape (<< 14.2.6~)
Description: Backup Archiving Recovery Open Sourced - storage daemon
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The storage daemon performs the storage and recovery of the file
 attributes and data to the physical media; in other words, it is
 responsible for reading and writing the backups.
 .
 It runs on the machine which has access to the backup device(s) - usually
 a tape drive, but alternatively other storage media, such as files.


Package:        bareos-storage-fifo
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0
Depends:        bareos-common (= ${binary:Version}), bareos-storage (= ${binary:Version}), lsb-base (>= 3.2-13), ${shlibs:Depends}, ${misc:Depends}
Description: Backup Archiving Recovery Open Sourced - storage daemon FIFO backend
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package contains the Storage backend for FIFO files.
 This package is only required, when a resource "Archive Device = fifo"
 should be used by the Bareos Storage Daemon.


Package:        bareos-storage-dedupable
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0
Depends:        bareos-common (= ${binary:Version}), bareos-storage (= ${binary:Version}), lsb-base (>= 3.2-13), ${shlibs:Depends}, ${misc:Depends}
Description: Backup Archiving Recovery Open Sourced - storage daemon DEDUP backend
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 This package contains the Storage backend for DEDUP files.
 This package is only required, when a resource "Archive Device = dedup"
 should be used by the Bareos Storage Daemon.


Package:        bareos-storage-tape
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0, adduser
Depends:        bareos-common (= ${binary:Version}), bareos-storage (= ${binary:Version}), lsb-base (>= 3.2-13), mtx, ${shlibs:Depends}, ${misc:Depends}
Recommends:     mt-st
Suggests:       scsitools, sg3-utils
Breaks:         bareos-storage (<< 14.2.6~)
Replaces:       bareos-storage (<< 14.2.6~)
Description: Backup Archiving Recovery Open Sourced - storage daemon tape support
 Bareos is a set of programs to manage backup, recovery and verification of
 data across a network of computers of different kinds.
 .
 The storage daemon performs the storage and recovery of the file
 attributes and data to the physical media; in other words, it is
 responsible for reading and writing the backups.
 .
 It runs on the machine which has access to the backup device(s) - usually
 a tape drive, but alternatively other storage media, such as files.
 .
 This adds the tape specific support files for the storage daemon.


Package:        bareos-tools
Architecture:   any
Pre-Depends:    debconf (>= 1.4.30) | debconf-2.0

## bareos 26.0.0~pre137.e32d578c3

=== debian/changelog ===
bareos (26.0.0~pre137.e32d578c3-2234) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Tue, 10 Feb 2026 11:30:56 +0000

## bareos 26.0.0~pre141.63a260b7a

=== debian/changelog ===
bareos (26.0.0~pre141.63a260b7a-2235) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Fri, 13 Feb 2026 17:06:37 +0000

## bareos 26.0.0~pre146.47c4c15f3

=== debian/changelog ===
bareos (26.0.0~pre146.47c4c15f3-2) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Wed, 18 Feb 2026 17:07:08 +0000

## bareos 26.0.0~pre147.da2c62069

=== debian/changelog ===
bareos (26.0.0~pre147.da2c62069-3) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Thu, 19 Feb 2026 09:41:56 +0000

## bareos 26.0.0~pre150.411f92d00

=== debian/changelog ===
bareos (26.0.0~pre150.411f92d00-2237) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Mon, 23 Feb 2026 10:11:36 +0000

## bareos 26.0.0~pre151.1233627e1

=== debian/changelog ===
bareos (26.0.0~pre151.1233627e1-1) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Wed, 25 Feb 2026 10:03:10 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
DH_VERBOSE = 1

# This has to be exported to make some magic below work.
DH_OPTIONS = -v

DAEMON_USER = bareos
DAEMON_GROUP = bareos
DIRECTOR_DAEMON_USER = $(DAEMON_USER)
STORAGE_DAEMON_USER = $(DAEMON_USER)
FILE_DAEMON_USER = root
STORAGE_DAEMON_GROUP = $(DAEMON_GROUP)
BAREOS_VERSION := $(shell dpkg-parsechangelog --show-field Version)
DIST_ID_REL := $(shell lsb_release --id --release --short | tr -d '\n')
WORK_DIR := $(shell pwd)

define CONFIGURE_COMMON
  -Dsbindir=/usr/sbin \
  -Dbindir=/usr/bin \
  -Dlibdir=/usr/lib/bareos \
  -Dsysconfdir=/etc \
  -Dconfdir=/etc/bareos \
  -Darchivedir=/var/lib/bareos/storage \
  -Dbackenddir=/usr/lib/bareos/backends \
  -Dconfigtemplatedir=/usr/lib/bareos/defaultconfigs \
  -Dscriptdir=/usr/lib/bareos/scripts \
  -Dplugindir=/usr/lib/bareos/plugins \
  -Dworkingdir=/var/lib/bareos \
  -Dlogdir=/var/log/bareos \
  -DSHARE_INSTALL_PREFIX:PATH=/usr/share \
  -Dwebuiconfdir=/etc/bareos-webui \
  -Dscsi-crypto=yes \
  -Dndmp=yes \
  -Ddir-user=$(DIRECTOR_DAEMON_USER) \
  -Ddir-group=$(DAEMON_GROUP) \
  -Dsd-user=$(STORAGE_DAEMON_USER) \
  -Dsd-group=$(STORAGE_DAEMON_GROUP) \
  -Dfd-user=$(FILE_DAEMON_USER) \
  -Dfd-group=$(DAEMON_GROUP) \
  -Ddir-password="XXX_REPLACE_WITH_DIRECTOR_PASSWORD_XXX" \
  -Dfd-password="XXX_REPLACE_WITH_CLIENT_PASSWORD_XXX" \
  -Dsd-password="XXX_REPLACE_WITH_STORAGE_PASSWORD_XXX" \
  -Dmon-dir-password="XXX_REPLACE_WITH_DIRECTOR_MONITOR_PASSWORD_XXX" \
  -Dmon-fd-password="XXX_REPLACE_WITH_CLIENT_MONITOR_PASSWORD_XXX" \
  -Dmon-sd-password="XXX_REPLACE_WITH_STORAGE_MONITOR_PASSWORD_XXX" \
  -Dbasename="XXX_REPLACE_WITH_LOCAL_HOSTNAME_XXX" \
  -Dhostname="XXX_REPLACE_WITH_LOCAL_HOSTNAME_XXX" \
  -Drpath=no \
  -DVERSION_STRING=$(BAREOS_VERSION)
endef


ifneq (,$(filter $(DIST_ID_REL), Debian11 Ubuntu20.04))
# debian 11 sadly ships with the last version of fmt that does not contain
# some needed functions that barri needs
# and ubuntu 20.04 does not have access to <span>
CONFIGURE_COMMON       += -DENABLE_BARRI=no
else
CONFIGURE_COMMON       += -DENABLE_BARRI=yes
endif

ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
CONFIGURE_COMMON       += -Dacl=no -Dxattr=no -Dscsi-crypto=no -Dndmp=no
endif
ifeq ($(DEB_HOST_ARCH_OS),hurd)
CONFIGURE_COMMON       += -Dscsi-crypto=no -Dndmp=no
endif


# no gprc for universal client, Ubuntu20.04 and Debian11
ifneq (build-universal-client,$(filter build-universal-client,$(DEB_BUILD_OPTIONS)))
	ifeq (,$(filter $(DIST_ID_REL),Debian11 Ubuntu20.04))
		CONFIGURE_COMMON       += -DENABLE_GRPC=yes
	endif
endif


override_dh_auto_configure:
ifeq (build-universal-client,$(filter build-universal-client,$(DEB_BUILD_OPTIONS)))
	echo "configuring universal client"
	dh_auto_configure -- $(CONFIGURE_COMMON) -DBUILD_UNIVERSAL_CLIENT=yes
else
	echo "configure full configuration"
	dh_auto_configure -- $(CONFIGURE_COMMON) -Dtraymonitor=yes
endif
	cmake --build cmake-build/ -- generate-debian-control


override_dh_fixperms:
	# all files in /etc/bareos
	dh_fixperms \
		--exclude etc/bareos/ \
		--exclude var/lib/bareos/ \
		--exclude var/log/bareos/


override_dh_strip:
ifeq (build-universal-client,$(filter build-universal-client,$(DEB_BUILD_OPTIONS)))
	dh_strip --dbg-package=bareos-universal-client-dbg
else
	dh_strip --dbg-package=bareos-dbg
endif


override_dh_systemd_enable:
ifeq (build-universal-client,$(filter build-universal-client,$(DEB_BUILD_OPTIONS)))
	dh_systemd_enable --name bareos-filedaemon
else
	dh_systemd_enable
endif


override_dh_installinit:
	# Skipped. Only use systemd configuration.


override_dh_systemd_start:
	dh_systemd_start bareos-filedaemon.service --no-start --restart-after-upgrade


override_dh_makeshlibs:
	dh_makeshlibs -n


override_dh_auto_test:
# Only run tests,
# if DEB_BUILD_OPTIONS does not contain nocheck,
# see https://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
# No tabs allowed before ifeq.
ifneq (nocheck,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd cmake-build && ls Testing/*/Test.xml || REGRESS_DEBUG=1 ctest -V -S CTestScript.cmake || echo "ctest result:$?"
else
	@echo "ctest: skipped"
endif


override_dh_shlibdeps:
	dh_shlibdeps -l$(shell pwd)/debian/tmp/usr/lib/bareos


%:
	dh $@ --builddirectory=cmake-build


gen-debian-copyright:
	(cd debian; make copyright)

## bareos 26.0.0~pre152.c515a922d

=== debian/changelog ===
bareos (26.0.0~pre152.c515a922d-8) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Wed, 18 Feb 2026 17:10:39 +0000
